# Describe an object

Provides a reference listing of each object that is available in your Zuora tenant.
The information returned by this call is useful if you are using [CRUD: Create Export](https://developer.zuora.com/v1-api-reference/api/exports/object_postexport) or the [AQuA API](https://docs.zuora.com?resourceId=platform-aqua-api-introduction) to create a data source export. See [Export ZOQL](https://docs.zuora.com?resourceId=platform-export-zoql) for more information.
### Response
The response contains an XML document that lists the fields of the specified object. Each of the object's fields is represented by a `<field>` element in the XML document.
Response sample:

```xml
<?xml version="1.0" encoding="UTF-8"?>
<object>
  <name>ProductRatePlanCharge</name>
  <label>Product Rate Plan Charge</label>
  <fields>
    ...
    <field>
      <name>TaxMode</name>
      <label>Tax Mode</label>
      <type>picklist</type>
      <options>
        <option>TaxExclusive</option>
        <option>TaxInclusive</option>
      </options>
      <contexts>
        <context>export</context>
      </contexts>
      ...
    </field>
    ...
  </fields>
</object>
```
It is strongly recommended that your integration checks `<contexts>` elements in the response. If your integration does not check `<contexts>` elements, your integration may process fields that are not available for use in data source exports. See [Changes to the Describe API](https://docs.zuora.com?resourceId=platform-export-zoql-changes-to-describe-api) for more information.

Endpoint: GET /v1/describe/{object}
Version: 2026-11-13
Security: bearerAuth

## Description:

  - `Response` ()
    The response contains an XML document that lists the fields of the specified object. Each of the object's fields is represented by a `<field>` element in the XML document. Response sample: ```xml
<?xml version="1.0" encoding="UTF-8"?>
<object>
  <name>ProductRatePlanCharge</name>
  <label>Product Rate Plan Charge</label>
  <fields>
    ...
    <field>
      <name>TaxMode</name>
      <label>Tax Mode</label>
      <type>picklist</type>
      <options>
        <option>TaxExclusive</option>
        <option>TaxInclusive</option>
      </options>
      <contexts>
        <context>export</context>
      </contexts>
      ...
    </field>
    ...
  </fields>
</object>
``` It is strongly recommended that your integration checks `<contexts>` elements in the response. If your integration does not check `<contexts>` elements, your integration may process fields that are not available for use in data source exports. See [Changes to the Describe API](https://docs.zuora.com?resourceId=platform-export-zoql-changes-to-describe-api) for more information.

## Security:

  - `bearerAuth` (unknown)
    http bearer

## Path parameters:

  - `object` (string, required)
    API name of an object in your Zuora tenant. For example, `InvoiceItem`. See [API object names for Describe](https://developer.zuora.com/v1-api-reference/api-object-names/) for the list of valid object names.
Depending on the features enabled in your Zuora tenant, you may not be able to list the fields of some objects.

## Query parameters:

  - `showCurrencyConversionInformation` (string)
    Set the value to `yes` to get additional currency conversion information in the result.
**Notes:**
- When **Automatically include additional Currency Conversion information** in currency conversion settings is checked, you can pass `yes` to get additional fields in the result. See [Configure Foreign Currency Conversion](https://docs.zuora.com?resourceId=ar-configure-foreign-currency-conversion) to check the **Automatically include additional Currency Conversion information**.
- By default if you need additional Currency Conversion information, submit a request at Zuora Global Support. Set this parameter value to `no` to not include the additional currency conversion information in the result.

  - `showRelationships` (boolean)
    Indicates whether to return joined objects information in the response. The default value is `false`, meaning no related object information is returned.
If you set this field to `true`, an additional `<related-objects />` section is returned. For example, if you are describing the Account object with this parameter set to `true`, the response will include information similar to the following snippet:

```xml
<related-objects>
  <object href="https://apisandbox-api.zuora.com/rest/api/describe/Contact">
    <name>BillToContact</name>
    <label>Bill To</label>
    <cardinality>TO_ONE</cardinality>
    <direct-relationship>true</direct-relationship>
    <path>Account.BillToContact</path>
  </object>
  ...
<related-objects>
```

## Header parameters:

  - `Accept-Encoding` (string)
    Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.
If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.

  - `Content-Encoding` (string)
    Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.
The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

  - `Zuora-Entity-Ids` (string)
    An entity ID. If you have [Zuora Multi-entity](https://docs.zuora.com?resourceId=platform-multi-entity-overview) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

  - `Zuora-Org-Ids` (string)
    Comma separated IDs. If you have Zuora Multi-Org enabled,
you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.
The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.

  - `Zuora-Version` (string)
    The minor API version.
For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response 200:

  - `200` (unknown)
    Returns an XML document that lists the fields of the specified object.

## Response 200 fields (text/xml):

  - `object` (object)
    The base object information.

  - `object.name` (string)
    Name of the base object.

  - `object.label` (string)
    Label of the base object in the Zuora UI.

  - `object.fields` (array)
    The fields on the base object.

  - `object.fields.name` (string)
    API name of the field.
    Example: Account

  - `object.fields.label` (string)
    Label of the field in the Zuora UI.
    Example: Account

  - `object.fields.type` (string)
    Data type of the field.
If the data type is `picklist`, the `<field>` element contains an `<options>` element that lists the possible values of the field.
    Enum: "boolean", "data", "datetime", "decimal", "integer", "picklist", "text", "timestamp", "ZOQL"

  - `object.fields.contexts` (array)
    The contexts of the API object, such as SOAP and REST.

  - `object.fields.contexts.context` (string)
    Example: soap

  - `object.related-objects` (array)
    The information of the related objects. This object is returned only if you specify the `showRelationships` query parameter to `true`.

  - `object.related-objects.name` (string)
    Name of the related object.
    Example: BillToContact

  - `object.related-objects.label` (string)
    Label of the related object in the Zuora UI.
    Example: Bill To

  - `object.related-objects.cardinality` (string)
    The cardinality between the base object and the related object.
    Example: TO_ONE

  - `object.related-objects.direct-relationship` (boolean)
    Indicates whether this object is directly joined with the base object.
    Example: true

  - `object.related-objects.path` (string)
    Describes how this object is joined from the base object.
    Example: Account.BillToContact

## Response 200 headers (text/xml):

  - `Content-Encoding` (string)
    This header is returned if you specify the `Accept-Encoding: gzip` request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
- `application/json`
- `application/xml`
- `text/html`
- `text/csv`
- `text/plain`

  - `RateLimit-Limit` (string)
    The request limit quota for the time window closest to exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Remaining` (number)
    The number of requests remaining in the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Reset` (number)
    The number of seconds until the quota resets for the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `Zuora-Request-Id` (string)
    The Zuora internal identifier of the API call. You cannot control the value of this header.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. 
If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. 
Otherwise, Zuora does not set this header.

  - `Concurrency-Limit-Type` (string)
    The type of the concurrency limit, which can be `Default`, `High-volume transactions`, or `Object Query`.
For more information, see [Concurrent request limits](https://developer.zuora.com/docs/guides/rate-limits/#concurrent-request-limits).

  - `Concurrency-Limit-Limit` (integer)
    The total number of the permitted concurrent requests.
For more information, see [Concurrent request limits](https://developer.zuora.com/docs/guides/rate-limits/#concurrent-request-limits).

  - `Concurrency-Limit-Remaining` (integer)
    The remaining number of the permitted concurrent requests.
For more information, see [Concurrent request limits](https://developer.zuora.com/docs/guides/rate-limits/#concurrent-request-limits).

## Response 404:

  - `404` (unknown)
    Returns an XML document that indicates the error

## Response 404 headers (text/xml; charset=utf-8):

  - `Content-Encoding` (string)
    This header is returned if you specify the `Accept-Encoding: gzip` request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
- `application/json`
- `application/xml`
- `text/html`
- `text/csv`
- `text/plain`

  - `RateLimit-Limit` (string)
    The request limit quota for the time window closest to exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Remaining` (number)
    The number of requests remaining in the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Reset` (number)
    The number of seconds until the quota resets for the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `Zuora-Request-Id` (string)
    The Zuora internal identifier of the API call. You cannot control the value of this header.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. 
If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. 
Otherwise, Zuora does not set this header.

  - `Concurrency-Limit-Type` (string)
    The type of the concurrency limit, which can be `Default`, `High-volume transactions`, or `Object Query`.
For more information, see [Concurrent request limits](https://developer.zuora.com/docs/guides/rate-limits/#concurrent-request-limits).

  - `Concurrency-Limit-Limit` (integer)
    The total number of the permitted concurrent requests.
For more information, see [Concurrent request limits](https://developer.zuora.com/docs/guides/rate-limits/#concurrent-request-limits).

  - `Concurrency-Limit-Remaining` (integer)
    The remaining number of the permitted concurrent requests.
For more information, see [Concurrent request limits](https://developer.zuora.com/docs/guides/rate-limits/#concurrent-request-limits).

## Response 500:

  - `500` (unknown)
    Internal Server Error

## Response 500 fields (application/json):

  - `reasons` (array)

  - `reasons.code` (string)
    The error code of response.

  - `reasons.message` (string)
    The detail information of the error response

## Response 500 headers (application/json):

  - `Content-Encoding` (string)
    This header is returned if you specify the `Accept-Encoding: gzip` request header and the response contains over 1000 bytes of data.
Note that only the following MIME types support gzipped responses:
- `application/json`
- `application/xml`
- `text/html`
- `text/csv`
- `text/plain`

  - `RateLimit-Limit` (string)
    The request limit quota for the time window closest to exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Remaining` (number)
    The number of requests remaining in the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `RateLimit-Reset` (number)
    The number of seconds until the quota resets for the time window closest to quota exhaustion. See [rate limits](https://developer.zuora.com/docs/guides/rate-limits/) for more information.

  - `Zuora-Request-Id` (string)
    The Zuora internal identifier of the API call. 
You cannot control the value of this header.

  - `Zuora-Track-Id` (string)
    A custom identifier for tracing the API call. 
If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. 
Otherwise, Zuora does not set this header.

## Response 500 examples:

  - `response` (unknown)

